---------------------------------------------------------------------------------------------------
function init_array(length,mode) local array={} for i=1,length do array[i]=mode end return array end 
function init_array_t(length) local array={} for i=1,length do array[i]={} end return array end
--------------------------------------------------------------------------------------------------
parse("mp_hud 0")
parse("mp_radar 0")
parse("sv_gamemode 2")
--parse("mp_")
--parse("")
---------------------------------------------------------------------------------------------------
function settile(x,y,tile)
	parse("settile "..x.." "..y.." "..tile)
end

function sound(soundfile) 
	parse("sv_sound \""..soundfile.."\"") 
	--print(soundfile)
end  

function sound2(uid,soundfile) 
	parse("sv_sound2 "..uid.." \""..soundfile.."\"") 
end 

function soundpos(soundfile,x,y,player)
	parse("sv_soundpos \""..soundfile.."\" "..x.." "..y.." "..player) 
end

function msg3(uid,text,delay)
	timer(delay or 1000,"parse","sv_msg2 "..uid.." "..text,1)
end

function hudtxtmove(uid,id,duration,x,y) 
	parse("hudtxtmove "..uid.." "..id.." "..duration.." "..x.." "..y) 
end  

function hudtxtalphafade(uid,id,duration,alpha) 
	parse("hudtxtalphafade "..uid.." "..id.." "..duration.." "..alpha) 
end  

function hudtxt_clear(...)
	local arg = {...}
	for _,id in ipairs(arg) do
		parse("hudtxt "..id.." \"\" 0 0")
	end	
end

function hudtxt(id,text,x,y,align,valign,size)
	parse("hudtxt "..id.." \""..text.."\" "..x.." "..y.." "..align.." "..valign.." "..size)
end

function hudtxt2(uid,id,text,x,y,align)
	parse("hudtxt2 "..uid.." "..id.." \""..text.."\" "..x.." "..y.." "..align)
end

function hud_popup(text,id,x,y,align,size,delay,direction) 
	local id=id or 0 
	local x=x or 425 
	local y=y or 220 
	local align=align or 1  
	local delay=delay or 1000
	
	hudtxt(id,text,x,y,align,1,size) 
	hudtxtalphafade(0,id,delay,0) 
	
	if direction=="up" or direction==nil then
		hudtxtmove(0,id,delay+2000,x,y-30) 
	elseif direction=="down" then
		hudtxtmove(0,id,delay+2000,x,y+30) 
	elseif direction=="left" then
		hudtxtmove(0,id,delay+2000,x-30,y) 
	elseif direction=="right" then
		hudtxtmove(0,id,delay+2000,x+30,y) 
	elseif direction=="center" then
		-- Nada
	end
end 
---------------------------------------------------------------------------------------------------

__timerArg={}
function timerex(ms,func,count,...)
	count=count or 1
	if count==0 then count=-1 end
	local tmpfunc,id="",0
	for i=1,8 do
		local rand=math.random(0,2)
		if rand==0 then
			tmpfunc=tmpfunc..string.char(math.random(65,90))
		elseif rand==1 then
			tmpfunc=tmpfunc..string.char(math.random(97,112))
		else
			tmpfunc=tmpfunc..math.random(0,9)
		end
	end
	table.insert(__timerArg,{type(func),tmpfunc,func,{...},count})
	for n,v in pairs(__timerArg) do
		if v[2]==tmpfunc then
			id=n
			break
		end
	end
	_G[tmpfunc]=function(id)
		id=tonumber(id)
		if __timerArg[id][1]=="function" then
			__timerArg[id].r=__timerArg[id][3](unpack(__timerArg[id][4]))
		elseif __timerArg[id][1]=="string" or __timerArg[id][1]=="number" then
			__timerArg[id].r=loadstring("return "..__timerArg[id][3].."(unpack(__timerArg["..id.."][4]))")()
		end
		__timerArg[id][5]=__timerArg[id][5]-1
		
		--print( id.." "__timerArg[id])
		--print(__timerArg[id])
		--print(__timerArg[id][2])
		--print(id)
		
		if __timerArg[id][5]==0 then
			_G[__timerArg[id][2]]=nil
			__timerArg[id]=nil
		end
	end
	timer(ms,tmpfunc,id,count)
	return id
end

function timerexists(id)
	return __timerArg[id]~=nil
end

_freetimer = freetimer
function freetimer(id)
	if __timerArg[id]~=nil then
		_freetimer(__timerArg[id][2],id)
		_G[__timerArg[id][2]]=nil
		__timerArg[id]=nil
		return true
	end
	return false
end

function string.split(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={} ; i=1
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                t[i] = str
                i = i + 1
        end
        return t
end

function table.value(tbl,value)
	for k,v in pairs(tbl) do
		if v==value then
			return v==value,k
		end	
	end
	return false
end

function table.shuffle(l, samp)
	local newlist
	newlist = {}
	if not samp then
		samp = 0
	else
		samp = #l - samp
	end
	while #l > samp do
		local idx
		idx = math.random(1, #l)
		newlist[#newlist + 1] = l[idx]
		table.remove(l, idx)
	end
	return newlist
end

function rpairs(t,reverse)
	local tk = {}
	for k, v in pairs(t) do
		tk[#tk+1] = k
	end
	tk=table.shuffle(tk)
	local i = 0
	return function()
		i = i + 1
		if tk[i] then
			return tk[i], t[ tk[i] ]
		end
	end
end

---------------------------------------------------------------------------------------------------
T_HEIGHT = 20
T_WIDTH = 10

T_POS_X = 2
T_POS_Y = 3

T_HOLD_X = 12
T_HOLD_Y = 16

T_QUEUE_X = 13
T_QUEUE_Y = 18

T_PIECE_SIZE=4
T_GRAVITY = 50

T_KEY_UP="uparrow"
T_KEY_LEFT="leftarrow"
T_KEY_DOWN="downarrow"
T_KEY_RIGHT="rightarrow"
T_KEY_CCW="Z"
T_KEY_CW="X"
T_KEY_180="A"
T_KEY_HARDDROP="space"
T_KEY_RESET="R"
T_KEY_HOLD="leftshift"

-- Delayed auto shift (in frames)
T_DAS=10

-- Auto repeat rate (in frames)
T_ARR=4

-- Soft drop rate (50 = 1 second)
T_SDF=45


--[[ Fast
-- Delayed auto shift (in frames)
T_DAS=5

-- Auto repeat rate (in frames)
T_ARR=1

-- Soft drop rate (50 = 1 second)
T_SDF=50
--]]


tetris = {}
tetris.clock = 0

tetris.board = {}
tetris.board.input_listener = 0
tetris.board.data = {}
tetris.board.arr = T_ARR -- Automatic repeat rate
tetris.board.das = T_DAS -- Delayed auto shift
tetris.board.sdf = T_SDF -- soft drop factor

tetris.board.arr_timer = 0

tetris.board.gravity_timer = 0
tetris.board.gravity_factor = T_GRAVITY
tetris.board.bag = {}
tetris.board.bag_current = {}
tetris.board.bag_next = {}
tetris.board.bag_queue = {0,0,0,0,0}
tetris.board.status = "stopped"
tetris.board.hold_piece = 0
tetris.board.hold_used = false
tetris.board.piece_count = 0
tetris.board.combo_counter = 0
tetris.board.b2b_counter = 1
tetris.board.score = 0
tetris.board.score_img = {}
tetris.board.bag_img = {}
tetris.board.hold_img = 0
for i=1,8 do
	tetris.board.score_img[i] = 0
	tetris.board.bag_img[i] = 0
end

tetris.piece = {}
tetris.piece.x = 0
tetris.piece.y = 0
tetris.piece.id = 0
tetris.piece.count = 0
tetris.piece.rotation = 0
tetris.piece.lock = false
tetris.piece.lock_timer = 0
tetris.piece.lock_reset = 0
tetris.piece.lastmove="translation"
tetris.piece.array = {}

for y = 1, T_HEIGHT do
	tetris.board.data[y]={}
		for x = 1, T_WIDTH do
		tetris.board.data[y][x]=0
	end
end

for y = 1,T_PIECE_SIZE do
	tetris.piece.array[y] = {}
	for x = 1,T_PIECE_SIZE do
		tetris.piece.array[y][x]=0
	end
end

tetris.pieceformat = {
	[1] = {
		0,0,0,0,
		1,1,1,1,
		0,0,0,0,
		0,0,0,0,
	};
	[2]={
		6,0,0,
		6,6,6,
		0,0,0,
	};
	[3]={
		0,0,8,
		8,8,8,
		0,0,0,
	};
	[4]={
		0,3,3,0,
		0,3,3,0,
		0,0,0,0,
	};
	[5]={
		0,2,2,
		2,2,0,
		0,0,0,
	};
	[6]={
		0,4,0,
		4,4,4,
		0,0,0,
	};
	[7]={
		5,5,0,
		0,5,5,
		0,0,0,
	};
}
tetris.srs = {
	{{0,0},{0,-1},{-1,-1},{ 2,0},{ 2,-1}},	--//L->0 : 3 1 % 4 = 0 - J, L, S, T, Z
	{{0,0},{0,-1},{ 1,-1},{-2,0},{-2,-1}},	--//0->R : 0 1 % 4 = 1
	{{0,0},{0, 1},{-1, 1},{ 2,0},{ 2, 1}},	--//R->2 : 1 1 % 4 = 2
	{{0,0},{0, 1},{ 1, 1},{-2,0},{-2, 1}},	--//2->L : 2 1 % 4 = 3
	{{0,0},{0, 1},{-1, 1},{ 2,0},{ 2, 1}},	--//R->0 : 1-1 % 4 = 0
	{{0,0},{0,-1},{ 1,-1},{-2,0},{-2,-1}},	--//2->R : 2-1 % 4 = 1
	{{0,0},{0,-1},{-1,-1},{ 2,0},{ 2,-1}},	--//L->2 : 3-1 % 4 = 2
	{{0,0},{0, 1},{ 1, 1},{-2,0},{-2, 1}},	--//0->L : 0-1 % 4 = 3
	{{0,0},{0, 1},{0,-2},{-2, 1},{ 1,-2}},	--//L->0 : 3 1 % 4 = 0 - I
	{{0,0},{0,-2},{0, 1},{-1,-2},{ 2, 1}},	--//0->R : 0 1 % 4 = 1
	{{0,0},{0,-1},{0, 2},{ 2,-1},{-1, 2}},	--//R->2 : 1 1 % 4 = 2
	{{0,0},{0, 2},{0,-1},{ 1, 2},{-2,-1}},	--//2->L : 2 1 % 4 = 3
	{{0,0},{0, 2},{0,-1},{ 1, 2},{-2,-1}},	--//R->0 : 1-1 % 4 = 0
	{{0,0},{0, 1},{0,-2},{-2, 1},{ 1,-2}},	--//2->R : 2-1 % 4 = 1
	{{0,0},{0,-2},{0, 1},{-1,-2},{ 2, 1}},	--//L->2 : 3-1 % 4 = 2
	{{0,0},{0,-1},{0, 2},{ 2,-1},{-1, 2}}   --//0->L : 0-1 % 4 = 3
} 


tetris.combo = {
	[1]=100, -- Single
	[2]=300, -- Double
	[3]=500, -- Triple
	[4]=800, -- Quad
	[5]=400, -- T-Spin (no line)
	[6]=800, -- T-Spin single
	[7]=1200, -- T-Spin double
	[8]=1600, -- T-Spin triple
	[9]=100, -- Mini T-Spin
	[10]=200, -- Mini T-Spin single 
	[11]=400, -- Mini T-Spin double
	[12]=3500, -- Perfect Clear
}

tetris.hud_update = function(piece_id)
	local piece_id = tetris.board.hold_piece
	local x,y = (T_QUEUE_X)*32+32, (T_QUEUE_Y)*32+16
	local hx,hy = (T_HOLD_X)*32+16, (T_HOLD_Y)*32+16
	local spreadsheet = "<spritesheet:gfx/tetris/hold.png:128:64>"

	if tetris.board.hold_img==0 then
		tetris.board.hold_img = image(spreadsheet, hx, hy, 3)
		imageframe(tetris.board.hold_img, piece_id+1)
		imagescale(tetris.board.hold_img, 0.25,0.25)
		
		if tetris.board.hold_used then
			imagecolor(tetris.board.hold_img, 80,80,80)
		else
			imagecolor(tetris.board.hold_img, 255,255,255)
		end
	else
		imageframe(tetris.board.hold_img, piece_id+1)
		if tetris.board.hold_used then
			imagecolor(tetris.board.hold_img, 80,80,80)
		else
			imagecolor(tetris.board.hold_img, 255,255,255)
		end
	end
	
	for i=1,5 do
		local queue_piece_id = tetris.board.bag_queue[i]
		if tetris.board.bag_img[i]==0 then
			tetris.board.bag_img[i] = image(spreadsheet, x, y + 38*(i-1), 3)
			imageframe(tetris.board.bag_img[i], queue_piece_id+1)
			imagescale(tetris.board.bag_img[i], 0.5,0.5)
		else
			imageframe(tetris.board.bag_img[i], queue_piece_id+1)
		end
	end
end

tetris.hud_score_update = function(score)
	local str = tostring(score or tetris.board.score)
	str=string.rep("0",8-string.len(str)).. str
	local m = {}
	for i=1,8 do
		m[i]=tonumber(string.sub(str,-(9-i),-(9-i)))
	end

	local x,y = (T_POS_X+(T_WIDTH/2))*32 - 16, (T_POS_Y+T_HEIGHT)*32 - 16 + 32

	local spreadsheet = "<spritesheet:gfx/hud_nums.bmp:48:66>"
	for i=1,8 do
		if tetris.board.score_img[i]==0 then
			tetris.board.score_img[i]=image(spreadsheet, x + (i*30)-(30*4), y, 3)
			imageframe(tetris.board.score_img[i], m[i]+1)
			imagescale(tetris.board.score_img[i], 0.56, 0.56)
			imagecolor(tetris.board.score_img[i], 255, 255, 0)
			imagealpha(tetris.board.score_img[i], 0.5)
			imageblend(tetris.board.score_img[i],1)
		else
			imageframe(tetris.board.score_img[i], m[i]+1)
		end
	end
end

tetris.hud_move_update = function(line,tspin,pc,combo,b2b)
	--function hud_popup(text,id,x,y,align,size,delay,direction) 
	
	local x,y = 20,50
	if tspin then
		hud_popup("\169150000255T - S P I N",1,x,y+50,0,30,2000,"right")
		sound("weapons/awp.wav")
	end

	if line==1 then
		hud_popup("\169255255255S I N G L E",2,x,y+100,0,50,2000,"right")
	elseif line==2 then
		hud_popup("\169255255255D O U B L E",2,x,y+100,0,50,2000,"right")
	elseif line==3 then
		hud_popup("\169255255255T R I P L E",2,x,y+100,0,50,2000,"right")
	elseif line==4 then
		hud_popup("\169255255255Q U A D",2,x,y+100,0,50,2000,"right")
	end
	
	if pc then
		hud_popup("\169255215000P E R F E C T   C L E A R",3,850/2,(450/2)+70,1,50,2200,"up")
		sound("fun/thats_the_way.wav")
	end

--function hudtxt(id,text,x,y,align,valign,size)
	if b2b>1 then
		hudtxt(4,"\169255215000B2B x "..(b2b-1),x,y+140,0,0,30)
	else
		hudtxt_clear(4)
	end
		
	if combo>0 then
		hudtxt(5,"\169255255255"..combo,x,y+200,0,1,50)
		hudtxt(6,"\169255255255COMBO",x+35,y+200,0,1,30)

		if combo==1 then
		elseif combo==2 then
			sound("fun/doublekill.wav")
		elseif combo==3 then
			sound("fun/multikill.wav")
		elseif combo==4 then
			sound("fun/ultrakill.wav")
		elseif combo==5 then
			sound("fun/monsterkill.wav")
		elseif combo==6 then
			sound("fun/rampage.wav")
		elseif combo==7 then
			sound("fun/godlike.wav")
		elseif combo>=8 then
			sound("fun/unstoppable.wav")
		end
	else
		hudtxt_clear(5,6)
	end
end

tetris.board.reset = function()
	for y = 1, T_HEIGHT do
	for x = 1, T_WIDTH do
		tetris.board.data[y][x]=0
	end
	end

	for y = 1,T_PIECE_SIZE do
	for x = 1,T_PIECE_SIZE do
		tetris.piece.array[y][x]=0
	end
	end
	
	tetris.piece.x=0
	tetris.piece.y=0
	tetris.piece.id=0
	tetris.piece.count=0
	tetris.piece.rotation=0
	tetris.piece.lock = false
	tetris.piece.lock_timer = 0
	tetris.piece.lock_reset = 0
	tetris.piece.lastmove="translation"
	tetris.board.status="playing"
	tetris.board.hold_piece = 0
	tetris.board.hold_used = false
	tetris.board.piece_count = 0
	
	tetris.board.combo_counter = 0
	tetris.board.b2b_counter = 1
	tetris.board.score = 0
	tetris.board.bag_current = tetris.board.createbag()
	tetris.board.bag_next = tetris.board.createbag()
	tetris.board.bag_queue = {0,0,0,0,0}
	
	tetris.piece.new()
	tetris.hud_score_update(0)
	hudtxt_clear(1,2,3,4,5,6,7)
end

tetris.board.hold = function()
	if tetris.board.hold_used==true then return end
	tetris.board.hold_used = true
	if tetris.board.hold_piece==0 then
		tetris.board.hold_piece = tetris.piece.id
		tetris.piece.new()
	else
		local temp_piece = tetris.piece.id
		tetris.piece.new(tetris.board.hold_piece)
		tetris.board.hold_piece = temp_piece
	end	
	tetris.hud_update()
end

tetris.board.createbag = function()
	local bag = {1,2,3,4,5,6,7}
	local sortedbag = table.shuffle(bag)

	--tetris.board.bag = sortedbag
	return sortedbag
end

tetris.board.next_piece = function()
	local current
	local count = tetris.board.piece_count
	local bagmod = (count % 7)
	local bag = {}
	if bagmod==0 then bagmod=7 end
	current = tetris.board.bag_current[bagmod]
	for i=1,5 do
		if tetris.board.bag_current[bagmod + i] then
			table.insert(bag, tetris.board.bag_current[bagmod + i])
		else
			table.insert(bag, tetris.board.bag_next[(bagmod-7) + i])  
		end
	end
	
	if bagmod==7 then
		tetris.board.bag_current = tetris.board.bag_next
		tetris.board.bag_next = tetris.board.createbag()
	end	
	tetris.board.bag_queue = bag
	return current
end


tetris.piece.new = function(piece_id)
	local blocked = false
	if piece_id then
	else
		tetris.board.piece_count = tetris.board.piece_count+1
	end	
		
	local piece_id = piece_id or tetris.board.next_piece()
	for y = 1,T_PIECE_SIZE do
	for x = 1,T_PIECE_SIZE do
		tetris.piece.array[y][x]=0
	end
	end

	local piece_data = tetris.pieceformat[piece_id]
	local piece_size_x = {[16]=4,[12]=4,[9]=3}
	local piece_size_y = {[16]=4,[12]=3,[9]=3}
	local i = 1
	for y = 1,piece_size_y[#piece_data] do
	for x = 1,piece_size_x[#piece_data] do
		tetris.piece.array[y][x]=piece_data[i]
		i = i + 1
				
		if tetris.board.data[y][x+3]~=0 and tetris.piece.array[y][x]~=0 then
			blocked = true
			
			parse("explosion "..((x+T_POS_X+3)*32-16).." "..((y+T_POS_Y)*32-16).." 20 0 0")
		end
	end
	end

	tetris.piece.id = piece_id
	tetris.piece.rotation = 0
	tetris.piece.x = 4
	tetris.piece.y = 1
	tetris.piece.lock = false
	tetris.piece.lock_timer = 0
	tetris.piece.lock_reset = 0
	
	
	tetris.hud_update()
	
			
	if blocked then
		tetris.board.status="gameover"
		--msg("blocked")
		tetris.drawgrid()
	end
end

tetris.piece.move = function(dx,dy,harddrop)
	tetris.piece.lock=false

	local new_x = tetris.piece.x + dx
	local new_y = tetris.piece.y + dy
	
	local colision = false
	local out_of_bound = false
	
	local piece_data = tetris.pieceformat[tetris.piece.id]
	local piece_size_x = {[16]=4,[12]=4,[9]=3}
	local piece_size_y = {[16]=4,[12]=3,[9]=3}
	local size_x = piece_size_x[#piece_data]
	local size_y = piece_size_y[#piece_data]
	local harddrop = harddrop or false

	for y = 1,size_y do
	for x = 1,size_x do
		local piece_tile_x = new_x + x - 1
		local piece_tile_y = new_y + y - 1
		local piece_tile_id = tetris.piece.array[y][x]
		
		if piece_tile_id~=0 and (
			piece_tile_y > T_HEIGHT 
			or piece_tile_x > T_WIDTH 
			or piece_tile_x < 1 
		)	
		then
			--print(piece_size_x[#piece_data],piece_size_y[#piece_data],new_x,new_y)
			out_of_bound=true
		end
		
		if tetris.board.data[piece_tile_y] 
		and tetris.board.data[piece_tile_y][piece_tile_x] 
		then
			local board_tile_id = tetris.board.data[piece_tile_y][piece_tile_x]
			if piece_tile_id~=0 and board_tile_id~=0 then
				colision = true
			end
		end
		
	end
	end
	
	--print(colision)
	if colision or out_of_bound then
		return true
	else
		if not harddrop then
			tetris.piece.lastmove = "translation"
			sound("weapons/knife_slash.wav")

		end		
		tetris.piece.x = new_x
		tetris.piece.y = new_y
		return false
	end	
end

tetris.piece.rotate = function(direction)
	if tetris.piece.lock then
		tetris.piece.lock=false
		tetris.piece.lock_reset=tetris.piece.lock_reset+1
	end	

	local piece_id = tetris.piece.id
	if piece_id==4 then 
		sound("weapons/melee.wav")
		return 
	end
	
	local piece_data = tetris.pieceformat[tetris.piece.id]
	local rotation_state = tetris.piece.rotation
	local piece_x = tetris.piece.x
	local piece_y = tetris.piece.y
	local direction = direction or "cw"
	local direction_abs = 1
	local piece_rotated = {}
	local piece_temp	= {}
	local piece_size_x = {[16]=4,[12]=4,[9]=3}
	local piece_size_y = {[16]=4,[12]=3,[9]=3}
	local size_x = piece_size_x[#piece_data]
	local size_y = piece_size_y[#piece_data]
	local offset_check=false

	-- Temporary table
	for y = 1, size_y do
		piece_temp[y]={}
		for x = 1,size_x do
			piece_temp[y][x]=tetris.piece.array[y][x]
		end
	end
	
	-- Rotate temporary table
	for y = 1,size_y do
		piece_rotated[y]={}
		for x = 1,size_x do
			if direction == "cw" then
				direction_abs = 1
				piece_rotated[y][x]=piece_temp[size_x-x+1][y]
			elseif direction == "ccw" then
				direction_abs = -1
				piece_rotated[y][x]=piece_temp[x][size_y-y+1]
			elseif direction == "180" then
				direction_abs = 2
				piece_rotated[y][x]=piece_temp[size_y-y+1][size_x-x+1]
			end
		end
	end
	
	local mod = ((rotation_state + direction_abs) % 4) + 1
	if direction_abs == -1 then 
		mod = mod + 4 
	end

	if piece_id==1 then
		mod = mod + 8
	end
	
	for __y = 1,size_y do
	for __x = 1,size_x do
	
		for test = 1, 5 do
			offset_check=true
			
			for cy = 1,size_y do
			for cx = 1,size_x do
				local piece_tile_cx = piece_x + cx - 1 + tetris.srs[mod][test][2]
				local piece_tile_cy = piece_y + cy - 1 - tetris.srs[mod][test][1]
				local piece_tile_cid = piece_rotated[cy][cx]
				
				if piece_tile_cid~=0 and (
					piece_tile_cy > T_HEIGHT or
					piece_tile_cx > T_WIDTH or
					piece_tile_cx < 1 
				) 
				then
					offset_check=false
					break
				end
				
				if tetris.board.data[piece_tile_cy] 
				and tetris.board.data[piece_tile_cy][piece_tile_cx] then
					local board_tile_cid = tetris.board.data[piece_tile_cy][piece_tile_cx]
					if piece_tile_cid~=0 and board_tile_cid~=0 then
						offset_check=false
						break
					end
				end
				
				
			end
				if offset_check==false then
					break
				end
			end
			
			
			if offset_check==true then
				-- SRS applied in piece
				local offset_y = tetris.srs[mod][test][1]
				local offset_x = tetris.srs[mod][test][2]
				
				tetris.piece.x = piece_x + offset_x
				tetris.piece.y = piece_y - offset_y
				for j = 1,size_y do
				for i = 1,size_x do
					tetris.piece.array[j][i] = piece_rotated[j][i]
				end
				end
				tetris.piece.rotation = tetris.piece.rotation + direction_abs
				if tetris.piece.rotation > 3 then
					tetris.piece.rotation = 0
				elseif tetris.piece.rotation < 0 then
					tetris.piece.rotation = 3
				end
				
				tetris.piece.lastmove="rotation"
				sound("weapons/knife_slash.wav")
				
				if (offset_y~=0 or offset_y~=0) and tetris.piece.id==6 then
					sound("weapons/deagle.wav")	
				end	
				return
			end
		end -- End of offset testing.

	end
	end
	--return offset_check,
end

tetris.piece.get = function(x,y)
	if x <= T_PIECE_SIZE and x > 0 and y <= T_PIECE_SIZE and y > 0 then
		return tetris.piece.array[y][x] or 0
	end
end

tetris.piece.copy = function()
	local piece_data = tetris.pieceformat[tetris.piece.id]
	local piece_size_x = {[16]=4,[12]=4,[9]=3}
	local piece_size_y = {[16]=4,[12]=3,[9]=3}
	local piece_x = tetris.piece.x
	local piece_y = tetris.piece.y
	local size_x = piece_size_x[#piece_data]
	local size_y = piece_size_y[#piece_data]
	local piece_temp = {}
	-- Temporary table
	for y = 1, size_y do
		piece_temp[y]={}
		for x = 1,size_x do
			piece_temp[y][x]=tetris.piece.array[y][x]
		end
	end
	
	-- Copy piece to board
	for y = 1,size_y do
	for x = 1,size_x do
		if piece_temp[y][x]~=0 then
			tetris.board.set(piece_x + x - 1, piece_y + y - 1, piece_temp[y][x])
		end	
	end
	end
end

tetris.piece.corners = function()
	local data = {}
	local count = 0
	--local piece_data = tetris.pieceformat[tetris.piece.id]
	local piece_x = tetris.piece.x
	local piece_y = tetris.piece.y
	
	--print(piece_x,piece_y)

	data[1] = tetris.board.get(piece_x+0, piece_y+0) or 0
	data[2] = tetris.board.get(piece_x+2, piece_y+0) or 0
	data[3] = tetris.board.get(piece_x+0, piece_y+2) or 0
	data[4] = tetris.board.get(piece_x+2, piece_y+2) or 0

	
	for i=1,4 do
		--print(data[i])
		if data[i]~=0 then
			count=count+1
		end
	end
	return count
end

tetris.board.get = function(x,y)
	if x <= T_WIDTH and x > 0 and y <= T_HEIGHT and y > 0 then
		return tetris.board.data[y][x] or 0
	end
end

tetris.board.set = function(x,y,id)
	if x <= T_WIDTH and x > 0 and y <= T_HEIGHT and y > 0 then
		tetris.board.data[y][x]=id
	end
end


tetris.piece.drop = function()
	local corners = tetris.piece.corners()
	local tspin = false
	tetris.piece.copy()
	
	
	local lines_cleared,perfect_clear = tetris.board.clear_line()
	local last_move = tetris.piece.lastmove 
	
	if last_move=="rotation" and tetris.piece.id==6 and corners>=3 then
		tspin=true
		--b2b=true
	end
	
	tetris.piece.new()
	tetris.board.hold_used=false
	--------------------------------------------------------------------------------
	local point_increase=0
	if lines_cleared>0 then
		if lines_cleared==4 then
			tetris.board.b2b_counter = tetris.board.b2b_counter+1
		else
			if tspin then
				tetris.board.b2b_counter = tetris.board.b2b_counter+1
			else
				tetris.board.b2b_counter = 1
			end
		end
		
		tetris.board.combo_counter = tetris.board.combo_counter + 1
		if tspin then
			point_increase = point_increase + tetris.combo[lines_cleared+5]				
		else
			point_increase = point_increase + tetris.combo[lines_cleared]				
		end	
		
		if perfect_clear then
			point_increase = point_increase + tetris.combo[12]				
		end
	else
		if tetris.board.combo_counter > 0 then
			tetris.board.combo_counter = 0
		end
	
		if tspin then
			point_increase = point_increase + tetris.combo[5]
		end
	end
	point_increase = point_increase + tetris.board.combo_counter*50
	point_increase = point_increase * tetris.board.b2b_counter
	
	tetris.board.score = tetris.board.score + point_increase
	
	tetris.hud_update()
	tetris.hud_score_update(tetris.board.score)
	tetris.hud_move_update(lines_cleared,tspin,perfect_clear,tetris.board.combo_counter,tetris.board.b2b_counter)
	
	sound("items/drop.wav")
end

function tetris.piece.harddrop()
	local falling = true
	local falling_count = 0
	
	while falling do 
		local colision = tetris.piece.move(0,1,true)

		falling_count = falling_count+1
		if colision then
			falling=false
			tetris.board.score = tetris.board.score + falling_count*2			
			tetris.piece.drop()
		end
	end	
end

tetris.board.clear_line = function()
	local lines_cleared=0
	for y = 1, T_HEIGHT do
		local clearable = true
		for x = 1, T_WIDTH do	
			local tile_id = tetris.board.get(x,y)
			if tile_id == 0 then
				clearable = false
			end
		end
		if clearable then
			lines_cleared = lines_cleared+1
			
			
			if lines_cleared > 2 then
				for x=1,T_WIDTH do
					parse("explosion "..((x+T_POS_X)*32-16).." "..((y+T_POS_Y)*32-16).." 10 0 0")
				end
			else
				sound("weapons/ak47.wav")
			end

			for line = y, 1,-1 do
				for column = 1, T_WIDTH do
					local temp_piece_id = tetris.board.get(column, line - 1) or 0
					tetris.board.set(column, line, temp_piece_id)
				end
			end
		end
	end

	local perfect_clear=true
	for y = 1, T_HEIGHT do
	for x = 1, T_WIDTH do
		if tetris.board.get(x,y)~=0 then
			perfect_clear=false
			break
		end
	end	
		if perfect_clear==false then break end
	end

	return lines_cleared,perfect_clear
end

function tetris.update()
	tetris.board.gravity_timer=tetris.board.gravity_timer+1
	if tetris.board.gravity_timer >= tetris.board.gravity_factor then
		tetris.board.gravity_timer = 0
		local colision = tetris.piece.move(0,1)
		if colision then
			tetris.piece.lock=true
		else
			if tetris.piece.lock then
				tetris.piece.lock=false
			end
		end
	end
	
	if tetris.piece.lock == true then
		tetris.piece.lock_timer=tetris.piece.lock_timer+1
		if tetris.piece.lock_timer >= 50 or tetris.piece.lock_reset>=4 then
			tetris.piece.drop()
		end
	end
end

function tetris.drawgrid()
	local temp_board = {}
	for y = 1,T_HEIGHT do
		temp_board[y] = {}
		for x = 1,T_WIDTH do
			 temp_board[y][x] = tetris.board.data[y][x]
		end
	end
	
	for y = 1,T_PIECE_SIZE do
	for x = 1,T_PIECE_SIZE do
		local tile_piece_id = tetris.piece.array[y][x] or 0
		if tile_piece_id ~= 0 then
			local piece_x = tetris.piece.x + x - 1
			local piece_y = tetris.piece.y + y - 1
			if temp_board[piece_y] and temp_board[piece_y][piece_x] then
				temp_board[piece_y][piece_x]=tile_piece_id
			end	
		end	
	end
	end

	for y = 1,T_HEIGHT do
		for x = 1,T_WIDTH do
			
			local tile_id  = tile(x+T_POS_X-1, y+T_POS_Y-1,"frame")
			--local tile_virtual_id = tetris.board.get(x,y)
			local tile_virtual_id = temp_board[y][x]
			if tile_id ~= tile_virtual_id then
				--print(tile_virtual_id)
				settile(x+T_POS_X-1,y+T_POS_Y-1,tile_virtual_id)
			end	
		end
	end 
end

addhook("always","tetris.always")
addhook("key","tetris.key")
addhook("use","tetris.use")
addhook("say","tetris.say")
addhook("startround","tetris.startround")

addbind(T_KEY_UP)
addbind(T_KEY_DOWN)
addbind(T_KEY_LEFT)
addbind(T_KEY_RIGHT)
addbind(T_KEY_CW)
addbind(T_KEY_CCW)
addbind(T_KEY_HARDDROP)
addbind(T_KEY_RESET)
addbind(T_KEY_HOLD)
addbind(T_KEY_180)


input_table = {}
input_key_timer = {}
for i=1,32 do
	input_table[i]={}
	input_key_timer[i] = 0
end
input_table[0]={}
input_key_timer[0]=0

function tetris.input(key,state)
	if tetris.board.status~="playing" then return end
	if key==T_KEY_HARDDROP and state== 1 then
		tetris.piece.harddrop()
	end
	if key==T_KEY_UP and state==1 then 
		tetris.piece.rotate("cw")
	end
	if key==T_KEY_LEFT and state==1 then 
		tetris.piece.move(-1,0)
	end
	if key==T_KEY_RIGHT and state==1 then 
		tetris.piece.move(1,0)
	end
	if key==T_KEY_CW and state==1 then 
		tetris.piece.rotate("cw")
	end
	if key==T_KEY_CCW and state==1 then 
		tetris.piece.rotate("ccw")
	end
	if key==T_KEY_180 and state==1 then
		tetris.piece.rotate("180")
	end
	
	--if key==T_KEY_RESET and state==1 then
		--tetris.board.reset()
	--end
	
	if key==T_KEY_HOLD and state==1 then
		tetris.board.hold()
	end
end

function tetris.say(uid,message)
	if message == "!slow" then
		tetris.board.das = 10
		tetris.board.arr = 4
		tetris.board.sdf = 45
	elseif message == "!fast" then
			tetris.board.das = 5
		tetris.board.arr = 1
		tetris.board.sdf = 50
	end
end

function tetris.key(uid,key,state)
	input_table[uid][key]=state
	
	if state==1 then
		input_key_timer[uid] = tetris.clock + tetris.board.das
	elseif state==0 then
	end	
	
	if uid==tetris.board.input_listener and tetris.board.status=="playing" then
		tetris.input(key,state)
	end	
end

function tetris.update_input()
	if tetris.board.status~="playing" then return end
	
	local uid = tetris.board.input_listener or 0

	if tetris.clock > input_key_timer[uid] then 
		tetris.board.arr_timer = tetris.board.arr_timer + 1
		if tetris.board.arr_timer >= tetris.board.arr then
			tetris.board.arr_timer=0
			if input_table[uid][T_KEY_LEFT]==1 then
				tetris.piece.move(-1,0)
			elseif input_table[uid][T_KEY_RIGHT]==1 then
				tetris.piece.move(1,0)
			end
		end
	else
		--tetris.board.arr_timer=0
	end
	
	if input_table[uid][T_KEY_DOWN]==1 then
		tetris.board.gravity_factor = 50-tetris.board.sdf+1  --math.max(tetris.board.sdf-50,1)
	else
		tetris.board.gravity_factor = T_GRAVITY
	end

end

function tetris.always()
	if tetris.board.status=="stopped" then
	elseif tetris.board.status=="playing" then
		tetris.clock=tetris.clock+1
		
		tetris.update_input()
	
		tetris.update()
		tetris.drawgrid()
	end	
end

function tetris.use(uid,event,data,x,y)
	if event==100 then
		local trigger = entity(x,y,"trigger")
		if trigger=="start" then
			tetris.board.input_listener=uid
			tetris.board.reset()
			
			msg(player(uid,"name").." got the controls of board.")
			msg("")
			msg("Instructions: ")
			msg(""..T_KEY_LEFT:upper().." & "..T_KEY_RIGHT:upper()..": Move the piece left/right")
			msg(""..T_KEY_UP:upper()..": clockwise rotation")
			msg(""..T_KEY_DOWN:upper()..": soft (slow) drop")
			msg(""..T_KEY_HARDDROP:upper()..": hard (fast) drop ")
			msg(""..T_KEY_HOLD:upper()..": hold current piece")
			msg(""..T_KEY_CW:upper()..": clockwise rotation")
			msg(""..T_KEY_CCW:upper()..": counter clockwise rotation")
			msg(""..T_KEY_180:upper()..": 180 rotation")

			msg("")
			msg("Current configuration for piece velocity is: ")
			msg("Delayed auto shift: "..tetris.board.das.." frames")
			msg("Soft drop rate: "..tetris.board.sdf.." frames/sec")
			msg("automatic repeat rate: "..tetris.board.arr.." frames/sec")
			msg("type !fast or !slow to change configuration accordingly.")
			
		elseif trigger=="pause" then
			if tetris.board.status=="playing" then
				hudtxt(7,"\169255255255GAME PAUSED",850/2,450/2,1,1,30)
				tetris.board.status="paused"
			elseif tetris.board.status=="paused" then
				tetris.board.status="playing"
				hudtxt_clear(7)
			end	
		end

		if tetris.board.status=="playing" then
			if trigger=="rotate" then
				tetris.piece.rotate("cw")
			elseif trigger=="left" then 
				tetris.piece.move(-1,0)
			elseif trigger=="right" then 
				tetris.piece.move(1,0)
			elseif trigger=="hold" then 
				tetris.board.hold()
			elseif trigger=="drop" then 
				tetris.piece.harddrop()
			end
		end	
	end
end

function tetris.startround()
	

	tetris.board.score_img = {}
	tetris.board.bag_img = {}
	tetris.board.hold_img = 0
	for i=1,8 do
		tetris.board.score_img[i] = 0
		tetris.board.bag_img[i] = 0
	end
	
	
end

--tetris.board.reset()





